/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jsfSupport.managedBeans;

import java.util.ArrayList;
import java.util.List;

import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.bean.SessionScoped;
import javax.faces.model.SelectItem;
import javax.jws.WebService;

import persistence.jpa.entities.Address;
import persistence.jpa.entities.Company;
import persistence.jpa.entities.CompanyEntity;
import sessionBeans.CompanySBLocal;

/**
 *
 * @author jez04
 */
@ManagedBean
@SessionScoped
@WebService
public class CompanyMB {

    @EJB
    protected CompanySBLocal companySBLocal;
    
    @ManagedProperty(value="#{personAgendaMB}")
    protected PersonAgendaMB agendaMB;
    
    protected Company selectedCompany;
    /** Creates a new instance of CompanyMB */
    public CompanyMB() {
        selectedCompany = new Company();
    }
    
    public List<Company> getAllCompanies(){
        return companySBLocal.getAllCompanies();
    }

    public List<SelectItem> getAllCompaniesAsSelectItems(){
        
        List<Company> companies = companySBLocal.getAllCompanies();
        List<SelectItem> selItems = new ArrayList<SelectItem>(companies.size());
        for(Company c : companies){
            selItems.add(new SelectItem(c, c.getName() + "(" + c.getAddress().toString() + ")"));
        }
        return selItems;
    }

    public CompanyEntity getSelectedCompany() {
        return selectedCompany;
    }

    public void setSelectedCompany(Company selectedCompany) {
        this.selectedCompany = selectedCompany;
    }
    
    public String saveCompany(){
        companySBLocal.saveCompany(selectedCompany);
        return "/secured/listCompanies";
    }
    
    public String editCompany(Company c){
        setSelectedCompany(c);
        return "/secured/editCompany";
    }
    public String createCompany(){
        Company c = new Company();
        c.setAddress(new Address());
        setSelectedCompany(c);
        return "/secured/editCompany";
    }

    public PersonAgendaMB getAgendaMB() {
        return agendaMB;
    }

    public void setAgendaMB(PersonAgendaMB agendaMB) {
        this.agendaMB = agendaMB;
    }
 
    
}
