/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jsfSupport.managedBeans;

import java.util.Collections;
import sessionBeans.PersonAgendaLocal;
import java.util.Locale;
import javax.ejb.EJB;
import javax.faces.application.Application;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Employee;
import persistence.jpa.entities.Person;

/**
 *
 * @author jez04
 */
@ManagedBean
@javax.faces.bean.SessionScoped
public class LoginMB {

    @EJB
    protected PersonAgendaLocal pa;
    protected Person loggedUser = null;
    protected String userLogin;
    protected String userPasswd;
    protected String locale = null;

    public LoginMB(){
    }
    
    public String getLocale() {
        if(locale == null){
            FacesContext fc = FacesContext.getCurrentInstance();
            Application app = fc.getApplication();
            Locale locale = app.getDefaultLocale();
            return locale.toString();
        }
        return locale;
    }

    public void setLocale(String locale) {
        this.locale = locale;
    }


    public Person getLoggedUser() {
        return loggedUser;
    }

    public void setLoggedUser(Person loggedUser) {
        this.loggedUser = loggedUser;
    }

    public String getUserLogin() {
        return userLogin;
    }

    public void setUserLogin(String userLogin) {
        this.userLogin = userLogin;
    }

    public String getUserPasswd() {
        return userPasswd;
    }

    public void setUserPasswd(String userPasswd) {
        this.userPasswd = userPasswd;
    }

    public String setENLocale(){
        FacesContext.getCurrentInstance().getViewRoot().setLocale(Locale.ENGLISH);
        locale = "en";
        return "";
    }
    public String setCZLocale(){
        FacesContext.getCurrentInstance().getViewRoot().setLocale(new Locale("cs"));
        locale = "cs";
        return "";
    }

    public String login(){
        loggedUser = pa.login(userLogin, userPasswd);
        if(loggedUser != null){
            return "";
        }
        FacesMessage message = new FacesMessage("Incorrecr Login or Password", "Incorrecr Login or Password");
        FacesContext.getCurrentInstance().addMessage(null, message);
        return "";
    }

    public boolean isAutorized(){
        if(loggedUser != null)
            return true;
        return false;
    }
    public boolean isAutorizedAsCustomer(){
        if(loggedUser != null)
            if(loggedUser instanceof  Customer)
                return true;
        return false;
    }
    public boolean isAutorizedASEmployee(){
        if(loggedUser != null)
            if(loggedUser instanceof Employee)
                return true;
        return false;
    }
    
    public String logout(){
    	FacesContext.getCurrentInstance().getExternalContext().invalidateSession();
    	return "logout";
    }
}
