/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jsfSupport.managedBeans;

import javax.ejb.EJB;

import sessionBeans.PersonAgendaLocal;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.component.html.HtmlDataTable;
import javax.faces.model.SelectItem;
import javax.jws.WebService;

import persistence.jpa.entities.Address;
import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Employee;
import persistence.jpa.entities.Person;
import persistence.jpa.entities.Position;

/**
 *
 * @author jez04
 */
@ManagedBean
@SessionScoped
@WebService
public class PersonAgendaMB {

    @EJB
    protected PersonAgendaLocal agenda;

    protected Position position;
    protected Person editedPerson;
    protected Customer editedCustomer;
    protected Employee editedEmployee;
    protected List<Position> roles = new ArrayList<Position>();
    
    
    public List<Position> getRoles() {
		return roles;
	}


	public void setRoles(List<Position> roles) {
		this.roles = roles;
	}


	public String checkInstalled(){
        agenda.checkInstalled();
        return "";
    }

   
    public Person getEditedPerson() {
        return editedPerson;
    }

    public void setEditedPerson(Person editedPerson) {
        this.editedPerson = editedPerson;
    }

    public String createCustomer(){
        Customer c = new Customer();
        c.setAddress(new Address());
        editedCustomer = c;
        editedPerson = c;
        return "editCustomer";
    }
    public String createEmployee(){
        Employee e = new Employee();
        e.setAddress(new Address());
        setEditedPerson(e);
        setEditedEmployee(e);
        return "editEmployee";
    }

    public String saveEmployee(){
        editedEmployee = agenda.saveEmployee(editedEmployee);
        return "listPersons";

    }
    public String saveCustomer(){
        editedCustomer = agenda.saveCustomer(editedCustomer);
        return "listPersons";
    }
    public Customer getEditedCustomer() {
        return editedCustomer;
    }

    public void setEditedCustomer(Customer editedCustomer) {
        this.editedCustomer = editedCustomer;
    }

    public Employee getEditedEmployee() {
        return editedEmployee;
    }

    public void setEditedEmployee(Employee editedEmployee) {
        this.editedEmployee = editedEmployee;
    }


    public Collection<Person> getAllPersons(){
        return agenda.getAllPersons(0, 100, true);
    }
    public Collection<Employee> getAllEmployees(){
        return agenda.getAllEmployees(0, 50000, true);
    }

    public Position getPosition() {
        if(position == null){
            position = new Position();
        }
        return position;
    }

    public void setPosition(Position position) {
        this.position = position;
    }

    public String savePosition(){
        Position p = getPosition();
        agenda.savePosition(p);
        return "/listPositions";
    }

    public Collection<Position> getAllPositions(){
        return agenda.getAllPositions(0,100, true);
    }

    public String editPosition(Position p){
        setPosition(p);
        return "editPosition";
    }
    
    public String editPerson(Person p){
        if(p instanceof Employee){
            return editEmployee((Employee)p);
        }
        if(p instanceof Customer){
            return editCustomer((Customer)p);
        }
        return "";
    }
    public String editEmployee(Employee e){
        setEditedEmployee(e);
        setEditedPerson(e);
        agenda.getEmployeeById(e.getId(), true);
        return "editEmployee";
    }
    public String editCustomer(Customer c){
        setEditedCustomer(c);
        setEditedPerson(c);
        return "/secured/editCustomer";
    }

    public String newPosition(){
        Position p = new Position();
        setPosition(p);
        return "editPosition";
    }
    public List<SelectItem> getAllPositionsASSelectItem(){
        Collection<Position> allPos = getAllPositions();
        ArrayList<SelectItem> selItems = new ArrayList<SelectItem>(allPos.size());
        for(Position p : allPos){
            selItems.add(new SelectItem(p, p.getName()));
        }
        return selItems;
        
    }

    public List<SelectItem> getAllEmployeesASSelectItem(){
        Collection<Employee> allEmp = getAllEmployees();
        ArrayList<SelectItem> selItems = new ArrayList<SelectItem>(allEmp.size());
        for(Employee e : allEmp){
            selItems.add(new SelectItem(e, e.getName() + " " + e.getSurename()));
        }
        return selItems;
        
    }
    
    public String assignPosition(){
        agenda.assign(getEditedEmployee(), getPosition());
        return "/secured/listPersons";
    }
    
    public boolean isCustomer(Person p){
        return (p instanceof Customer);

    }
    
    public boolean isEmployee(Person p){
        return (p instanceof Employee);
    }
}
