/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jsfSupport.managedBeans;

import java.util.Date;
import java.util.List;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;

import persistence.jpa.entities.Comment;
import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Employee;
import persistence.jpa.entities.Person;
import persistence.jpa.entities.Request;
import persistence.jpa.entities.Status;
import sessionBeans.RequestSBLocal;

/**
 *
 * @author jez04
 */
@ManagedBean
@SessionScoped
public class RequestSupport {

    @EJB
    protected RequestSBLocal requestSB;

    @ManagedProperty(value="#{loginMB}")
    private LoginMB loginMB;

    protected int startIndex = 0;
    protected int tabLength = 10;
    protected Request edited;
    protected Person person;

    protected String comment;

    public LoginMB getLoginMB() {
		return loginMB;
	}

	public void setLoginMB(LoginMB loginMB) {
		this.loginMB = loginMB;
	}

	public List<Request> getAllRequests(){
        return requestSB.getAllRequests(0, 10);
    }

    public String createNew(){
        edited = new Request();
        edited.setStatus(Status.NEW);
        return "editRequest";
    }

    public String saveEdited(){
        if(loginMB.getLoggedUser() instanceof Customer){
    		edited.setAutor((Customer)loginMB.getLoggedUser());
    		requestSB.saveRequest(edited);
            return "success";
        } else {
    		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Employee cannot create request.", "Employee cannot create request."));
    		return "";
        }
    }
    public Request getEdited() {
        return edited;
    }



    public void setEdited(Request edited) {
        this.edited = edited;
    }

    public int getStartIndex() {
        return startIndex;
    }

    public void setStartIndex(int startIndex) {
        this.startIndex = startIndex;
    }

    public int getTabLength() {
        return tabLength;
    }

    public void setTabLength(int tabLength) {
        this.tabLength = tabLength;
    }


    public boolean isCustomer(){
    	return person instanceof Customer;
    }

    public boolean isEmploeey(){
    	return person instanceof Employee;
    }
	
    public Person getPerson() {
		return person;
	}

	public void setPerson(Person person) {
		this.person = person;
	}

	public List<Request> getRequestForPerson(){
		if(person == null){
			person = loginMB.getLoggedUser();
		}
		return requestSB.getRequestFor(person);
	}

	public String showDetail(Request request){
		edited = requestSB.loadDiscusion(request);
		return "requestDetail";
	}
	
	public String showRequest(Person person){
		this.person = person;
		return "listRequests";
	}
	
	public Status[] getStatuses(){
		return Status.values();
	}
	
	public String serveRequest(){
		return "listRequestToAssign";
	}
	
	public String assign(Request request, Person person){
		if(person instanceof Employee){
			request.setAssigned((Employee)person);
			request.setStatus(Status.ASSIGNED);
			requestSB.saveRequest(request);
			return "listRequests";
		} else {
    		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Customer cannot take request.", "Customer cannot take request."));
    		return "";
		}
		
	}
	
	
	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	public List<Request> getUnassignedRequest(){
		return requestSB.getUnassignedRequest();
	}
	
	public String addComment(){
		Comment c = new Comment();
		c.setAutor(loginMB.getLoggedUser());
		c.setComment(comment);
		c.setCommentFor(edited);
		c.setTime(new Date());
		requestSB.saveCommnet(c);
		edited = requestSB.loadDiscusion(edited);
		comment = "";
		return "";
	}
}
