/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.dao;

import java.util.List;

import javax.persistence.EntityManager;

import persistence.jpa.entities.Comment;
import persistence.jpa.entities.Request;

/**
 *
 * @author jez04
 */
public class CommentDao extends EntityDao<Comment>{

    public CommentDao(EntityManager em) {
    	super(em);
    }

    public Comment saveCommnet(Comment com){
    	if(com.getId() == null){
    		em.persist(com);
    	} else {
    		com = em.merge(com);
    	}
        em.flush();
        if(com.getAutor() != null){
        	em.refresh(em.merge(com.getAutor()));
        }
        if(com.getCommentFor() != null){
        	Request request = em.merge(com.getCommentFor());
        	em.refresh(request);
        }
        return com;
    }

    public int getCommentsForCount(int requestId){
        return (Integer)em.createQuery("SELECT count(c) FROM Commnet c WHERE c.commentFor.id=?1")
                .setParameter(1, requestId)
                .getSingleResult();
    }
    public List<Comment> getCommentsFor(int requestId, int start, int length){
        return em.createQuery("SELECT c FROM Commnet WHERE c.commentFor.id=?1").
                setParameter(1, requestId)
                .setFirstResult(start)
                .setMaxResults(length).getResultList();
    }

    public int getCommentsFromCount(int authorId){
        return (Integer)em.createQuery("SELECT count(c) FROM Commnet c WHERE c.author.id=?1").
                setParameter(1, authorId)
                .getSingleResult();
    }
    public List<Comment> getCommentsFrom(int authorId, int start, int length){
        return em.createQuery("SELECT c FROM Commnet c WHERE c.author.id=?1").
                setParameter(1, authorId)
                .setFirstResult(start)
                .setMaxResults(length).getResultList();
    }

    public List<Comment> searchInComments(String text) {
        return em.createQuery("SELECT c FROM Cooment c WHERE c.comment LIKE ?1").
                setParameter(1, "%" + text + "%").getResultList();
    }

	@Override
	protected Class getEntityClass() {
		return Comment.class;
	}
}
