/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.dao;

import javax.persistence.EntityManager;

import persistence.jpa.entities.Request;

/**
 *
 * @author jez04
 */
public class DaoFactory {

    protected EntityManager em;

    protected PositionDao positionDao;
    protected AddressDao addressDao;
    protected CommentDao commentDao;
    protected CompanyDao companyDao;
    protected CustomerDao customerDao;
    protected EmployeeDao employeeDao;
    protected PersonDao personDao;
    protected RequestDao requestDao;

    private static DaoFactory daoFactory;
    public static DaoFactory getInstance(EntityManager em){
    	if(daoFactory == null){
    		daoFactory = new DaoFactory(em);
    	}
    	return daoFactory;
    }
    private DaoFactory(EntityManager em) {
        this.em = em;
    }

    public PositionDao getPositionDao() {
        if(positionDao == null){
            positionDao = new PositionDao(em);
        }
        return positionDao;
    }

    public AddressDao getAddressDao() {
        if(addressDao == null){
            addressDao = new AddressDao(em);
        }
        return addressDao;
    }

    public CommentDao getCommentDao() {
        if(commentDao == null){
            commentDao = new CommentDao(em);
        }
        return commentDao;
    }

    public CompanyDao getCompanyDao() {
        if(companyDao == null){
            companyDao = new CompanyDao(em);
        }
        return companyDao;
    }

    public CustomerDao getCustomerDao() {
        if(customerDao == null){
            customerDao = new CustomerDao(em);
        }
        return customerDao;
    }

    public EmployeeDao getEmployeeDao() {
        if(employeeDao == null){
            employeeDao = new EmployeeDao(em);
        }
        return employeeDao;
    }

    public PersonDao getPersonDao() {
        if(personDao == null){
            personDao = new PersonDao(em);
        }
        return personDao;
    }

    public RequestDao getRequestDao() {
        if(requestDao == null){
            requestDao = new RequestDao(em);
        }
        return requestDao;
    }
	public Request loadDiscusion(Request request) {
		request = em.merge(request);
		em.refresh(request);
		request.getDiscusion().size();
		return request;
	}

}
