/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.dao;

import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.List;

import javax.persistence.EntityManager;

import persistence.jpa.entities.Address;
import persistence.jpa.entities.Employee;
import persistence.jpa.entities.Person;
import persistence.jpa.entities.Position;

/**
 *
 * @author jez04
 */
public class PersonDao extends EntityDao<Person>{

    public PersonDao(EntityManager em) {
    	super(em);
    }

    public Collection<Person> getAllPersons(int index, int length, boolean initPositionList) {
        Collection<Person> col = getAll(index, length);
        for(Person p: col){
        	if(p instanceof Employee){
        		((Employee)p).getPositions().size();
        	}
        }
        return col;
    }

    public Person login(String userName, String passwd) {
        List<Person> persons = em.createQuery("select p from Person p where p.loginName=?1 and p.passwd=?2").
                setParameter(1, userName).setParameter(2, passwd).setMaxResults(1).getResultList();
        if(persons.size() > 0){
            return persons.get(0);
        }
        return null;

    }

    public void checkInstalled() {
    	System.out.println("installing");
        Long adminCount = (Long)em.createQuery("select count(e) from Employee e where e.loginName='admin' and e.passwd='admin'").getSingleResult();
        if(adminCount == 0){
                Employee e = new Employee();
                e.setName("Thomas A.");
                e.setSurename("Anderson");
                e.setEmail("neo@matrix.virtual.dot");
                Calendar c = Calendar.getInstance();
                c.set(2010, 11, 1);
                System.out.println("day: " + c.get(Calendar.DATE) + " Month:" + c.get(Calendar.MONTH)+ " Year:"+c.get(Calendar.YEAR));
                System.out.println(DateFormat.getInstance().format(c.getTime()));
                e.setDateOfBirth(c.getTime());
                e.setLoginName("admin");
                e.setPasswd("admin");
                e.setPhone("555 666 777");
                e.setSalary(150879);
                Address a = new Address("51th Avenue", "New York", "48759", "United States of America");
                e.setAddress(a);
                em.persist(e);
                Position p = new Position("Administrator", "Administrate whole matrix and has heroic task to solve.");
                em.persist(p);
                ArrayList<Position> pList = new ArrayList<Position>();
                pList.add(p);
                e.setPositions(pList);
                ArrayList<Employee> eList = new ArrayList<Employee>();
                eList.add(e);
                p.setStaffs(eList);
                em.flush();
        }
    }

	@Override
	protected Class getEntityClass() {
		return Person.class;
	}

}
