/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.dao;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.FlushModeType;

import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Employee;
import persistence.jpa.entities.Request;
import persistence.jpa.entities.Status;


/**
 *
 * @author jez04
 */
public class RequestDao extends EntityDao<Request> {

    public RequestDao(EntityManager em) {
    	super(em);
    }

    public Request save(Request request) {
        if(request.getId() == null || request.getId() == 0){
            em.persist(request);
        }
        else{
            em.merge(request);
            em.flush();
        }
        if(request.getAutor() != null){
        	Customer c = em.merge(request.getAutor());
        	em.refresh(c);
        }
    	if(request.getAssigned() != null){
    		Employee employee = em.merge(request.getAssigned());
    		em.refresh(employee);
    	}
        return request;
    }

	public List<Request> getUnassignedRequests() {
		return em.createQuery("select r from Request r where r.status = :state").setParameter("state", Status.NEW).getResultList();
	}

	@Override
	protected Class getEntityClass() {
		return Request.class;
	}

}
