/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.entities;

import javax.persistence.Entity;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

/**
 *
 * @author jez04
 */
@NamedQueries({
	@NamedQuery(name="Address.all", query="SELECT a FROM Address a"),
	@NamedQuery(name="Address.allCount", query="SELECT count(a) FROM Address a")
})
@Entity
public class Address extends CompanyEntity {
    private static final long serialVersionUID = 1L;

    protected String street;
    protected String city;
    protected String postcode;
    protected String county;

    public Address() {
    }

    public Address(String street, String city, String postcode, String county) {
        this.street = street;
        this.city = city;
        this.postcode = postcode;
        this.county = county;
    }
    
    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getCounty() {
        return county;
    }

    public void setCounty(String county) {
        this.county = county;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getPostcode() {
        return postcode;
    }

    public void setPostcode(String postcode) {
        this.postcode = postcode;
    }

    public String getStreet() {
        return street;
    }

    public void setStreet(String street) {
        this.street = street;
    }

    public String getFormatedAddress(){
        String s = getStreet() + ", " + getCity() + ", "
                + getPostcode() + ", " + getCounty();
        return s;
    }

    
    @Override
    public String toString() {
        return street + ", " + postcode + " " + city + ", " + county;
    }



}
