/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.entities;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author jez04
 */
@NamedQueries({
	@NamedQuery(name="Company.all", query="SELECT c FROM Company c"),
	@NamedQuery(name="Company.allCount", query="SELECT count(c) FROM Company c")
})
@Entity
public class Company extends CompanyEntity {
    private static final long serialVersionUID = 1L;
    
    @Column(length=100, nullable=false)
    protected String name;
    @OneToOne(cascade= {CascadeType.ALL})
    protected Address address;
    @OneToMany(fetch=FetchType.LAZY, mappedBy="company")
    protected List<Customer> contacts;


    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }


    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }

    public List<Customer> getContacts() {
        return contacts;
    }

    public void setContacts(List<Customer> contacts) {
        this.contacts = contacts;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public String toString() {
        return "Company{" + "id=" + id + "name=" + name + "address=" + address + "contacts=" + contacts + '}';
    }


}
