/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.entities;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author jez04
 */
@NamedQueries({
	@NamedQuery(name="Employee.all", query="SELECT e FROM Employee e"),
	@NamedQuery(name="Employee.allCount", query="SELECT count(e) FROM Employee e")
})

@Entity
public class Employee extends Person {
    private static final long serialVersionUID = 1L;

    protected int salary;
    @ManyToMany(fetch=FetchType.EAGER)
    protected List<Position> positions;
    @Temporal(TemporalType.DATE)
    protected Date dateOfBirth;
    @OneToMany(fetch=FetchType.LAZY, mappedBy="assigned")
    protected List<Request> assignedRequests;

    public int getAge(){
        Calendar now = Calendar.getInstance();
        Calendar bd = Calendar.getInstance();
        if(dateOfBirth == null){
            return 0;
        }
        bd.setTime(dateOfBirth);
        int age = now.get(Calendar.YEAR) - bd.get(Calendar.YEAR);
        Calendar bd2 = (Calendar)bd.clone();
        bd2.set(Calendar.YEAR, now.get(Calendar.YEAR));
        if(now.compareTo(bd) < 0){
            age -= 1;
        }
        return age;
    }

    public List<Request> getAssignedRequests() {
        return assignedRequests;
    }

    public void setAssignedRequests(List<Request> assignedRequests) {
        this.assignedRequests = assignedRequests;
    }

    public Date getDateOfBirth() {
        return dateOfBirth;
    }

    public void setDateOfBirth(Date dateOfBirth) {
        this.dateOfBirth = dateOfBirth;
    }

    public List<Position> getPositions() {
        return positions;
    }

    public void setPositions(List<Position> positions) {
        this.positions = positions;
    }

    public int getSalary() {
        return salary;
    }

    public void setSalary(int salary) {
        this.salary = salary;
    }

    @Override
    public String toString() {
        return "Employee{" + "salary=" + salary + "positions=" + positions + "dateOfBirth=" + dateOfBirth + "assignedRequests=" + assignedRequests + "position=" + super.toString() + '}';
    }





}
