/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.entities;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToOne;

/**
 *
 * @author jez04
 */

@NamedQueries({
	@NamedQuery(name="Person.all", query="SELECT p FROM Person p"),
	@NamedQuery(name="Person.allCount", query="SELECT count(p) FROM Person p")
})
@Entity
@Inheritance(strategy=InheritanceType.JOINED)
public class Person extends CompanyEntity implements Serializable{

	protected String name;
    protected String surename;
    protected String phone;
    protected String email;
    @OneToOne(fetch=FetchType.EAGER, cascade=CascadeType.ALL)
    protected Address address;
    protected String loginName;
    protected String passwd;

    public Address getAddress() {
        return address;
    }

    public void setAddress(Address address) {
        this.address = address;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getSurename() {
        return surename;
    }

    public void setSurename(String surename) {
        this.surename = surename;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getPasswd() {
        return passwd;
    }

    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }

    @Override
    public String toString() {
        return "Person{" + "id=" + id + "name=" + name + "surename=" + surename + "phone=" + phone + "email=" + email + "address=" + address + '}';
    }

    public Person() {
    }

    public Person(String name, String surename, String phone, String email, Address address) {
        this.name = name;
        this.surename = surename;
        this.phone = phone;
        this.email = email;
        this.address = address;
    }

    
}
