/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package persistence.jpa.entities;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;

/**
 *
 * @author jez04
 */
@NamedQueries({
	@NamedQuery(name="Request.all", query="SELECT r FROM Request r"),
	@NamedQuery(name="Request.allCount", query="SELECT count(r) FROM Request r")
})

@Entity
public class Request extends CompanyEntity {
    private static final long serialVersionUID = 1L;

    private String name;
    
    @Column(length=2048)
    private String description;
    @ManyToOne(fetch=FetchType.EAGER)
    private Employee assigned;
    @ManyToOne(fetch=FetchType.EAGER)
    private Customer autor;
    @Enumerated(EnumType.ORDINAL)
    private Status status;
    @OneToMany(fetch=FetchType.LAZY, mappedBy="commentFor", cascade=CascadeType.ALL)
    @OrderBy("time ASC")
    private List<Comment> discusion;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Status getStatus() {
        return status;
    }

    public void setStatus(Status status) {
        this.status = status;
    }

    public Employee getAssigned() {
        return assigned;
    }

    public void setAssigned(Employee assigned) {
        this.assigned = assigned;
    }

    public Customer getAutor() {
        return autor;
    }

    public void setAutor(Customer autor) {
        this.autor = autor;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public List<Comment> getDiscusion() {
        return discusion;
    }

    public void setDiscusion(List<Comment> discusion) {
        this.discusion = discusion;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    
    @Override
    public String toString() {
        return "Request{" + "id=" + id + "name=" + name + "description=" + description + "assigned=" + assigned + "autor=" + autor + "status=" + status + "discusion=" + discusion + '}';
    }


}
