/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sessionBeans;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.jws.WebService;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import persistence.jpa.dao.DaoFactory;
import persistence.jpa.entities.Company;
import persistence.jpa.entities.CompanyEntity;
import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Position;

/**
 *
 * @author jez04
 */
@Stateless
public class CompanySB implements CompanySBLocal {

    @PersistenceContext
    protected EntityManager em;

    protected DaoFactory dao;

    @PostConstruct  
    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    public void init(){
        dao = DaoFactory.getInstance(em);
        checkInstall();
    }

    public void checkInstall(){
        dao.getPersonDao().checkInstalled();
    }
    @Override
    public Company saveCompany(Company company) {
        return dao.getCompanyDao().saveCompany(company);
    }

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")

    @Override
    public Company getCompanyById(Long id) {
        return dao.getCompanyDao().find(id);
    }

    @Override
    public List<Company> getAllCompanies() {
        List<Company> companies = dao.getCompanyDao().getAll(0, Integer.MAX_VALUE);
        return companies;
    }

	@Override
	public Position getPositionById(Long id) {
		return dao.getPositionDao().find(id);
	}

	@Override
	public Customer getCustomerById(Long id) {
		return dao.getCustomerDao().find(id);
	}
    
}
