/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sessionBeans;

import persistence.jpa.entities.Position;
import persistence.jpa.entities.Person;
import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Employee;
import persistence.jpa.dao.DaoFactory;

import java.util.Collection;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author jez04
 */
@Stateless
public class PersonAgendaSB implements PersonAgendaLocal {

    @PersistenceContext
    protected EntityManager em;

    protected DaoFactory dao;

    @PostConstruct
    public void init(){
        dao = DaoFactory.getInstance(em);
        checkInstalled();
    }
    @Override
    public Collection<Person> getAllPersons(int index, int length, boolean initPositionList) {
        return dao.getPersonDao().getAllPersons(index, length, initPositionList);
    }

    @Override
    public void savePosition(Position position) {
        dao.getPositionDao().savePosition(position);
    }

    @Override
    public Collection<Position> getAllPositions(int startIndex, int length, boolean initStaffList) {
        return dao.getPositionDao().getAllPositions(startIndex, length, initStaffList);
    }

    @Override
    public Person login(String userName, String passwd) {
        return dao.getPersonDao().login(userName, passwd);
    }

    @Override
    public void checkInstalled() {
        dao.getPersonDao().checkInstalled();
    }

    @Override
    public List<Customer> getAllCustomers(int index, int length) {
    	return (List<Customer>)dao.getCustomerDao().getAll(index, length);
    }

    @Override
    public List<Employee> getAllEmployees(int index, int length, boolean initPositionList) {
        return dao.getEmployeeDao().getAllEmployees(index, length, initPositionList);
    }

    @Override
    public Customer saveCustomer(Customer customer) {
        return dao.getCustomerDao().saveCustomer(customer);
    }

    @Override
    public Employee saveEmployee(Employee employee) {
        return dao.getEmployeeDao().saveEmployee(employee);
    }

    


    
    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")

    @Override
    public Employee getEmployeeById(Long id) {
        return dao.getEmployeeDao().find(id);
    }

	@Override
	public Employee getEmployeeById(Long id, boolean initPositionList) {
		Employee e = dao.getEmployeeDao().find(id);
		e.getPositions().size();
		return e;
	}

	@Override
    public Position getPositionById(Long id) {
        return dao.getPositionDao().find(id);
    }

    @Override
    public void assign(Employee e, Position p) {
        dao.getPositionDao().assign(e, p);
        //dao.getEmployeeDao().refresh(e);

    }
	@Override
	public Person getPersonById(Long id) {
		return dao.getPersonDao().find(id);
	}
}
