/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sessionBeans;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import persistence.jpa.dao.DaoFactory;
import persistence.jpa.entities.Comment;
import persistence.jpa.entities.Customer;
import persistence.jpa.entities.Employee;
import persistence.jpa.entities.Person;
import persistence.jpa.entities.Request;

/**
 *
 * @author jez04
 */
@Stateless
public class RequestSB implements RequestSBLocal {

    @PersistenceContext
    protected EntityManager em;

    protected DaoFactory dao;

    @PostConstruct  
    public void init(){
        dao = DaoFactory.getInstance(em);
    }

    @Override
    public List<Comment> searchInComments(String text) {
        return dao.getCommentDao().searchInComments(text);
    }

    @Override
    public Request saveRequest(Request request) {
		return dao.getRequestDao().save(request);
    }

    @Override
    public Comment saveCommnet(Comment comment) {
        return dao.getCommentDao().saveCommnet(comment);
    }

    @Override
    public List<Request> getAllRequests(int index, int length) {
        return (List<Request>)dao.getRequestDao().getAll(index, length);
    }

    // Add business logic below. (Right-click in editor and choose
    // "Insert Code > Add Business Method")

    @Override
    public Request getRequestById(Long id) {
        return dao.getRequestDao().find(id);
    }

    @Override
    public Comment getCommentById(Long id) {
        return dao.getCommentDao().find(id);
    }

	@Override
	public List<Request> getRequestFor(Person person) {
		person = em.merge(person);
		if(person instanceof Customer){
			Customer customer = (Customer)person; 
			customer.getRequests().size();
			return customer.getRequests();
		}
		if(person instanceof Employee){
			Employee emploeey = (Employee)person;
			emploeey.getAssignedRequests().size();
			return emploeey.getAssignedRequests(); 
		}
		return null;
	}

	@Override
	public List<Request> getUnassignedRequest() {
		return dao.getRequestDao().getUnassignedRequests();
	}

	@Override
	public Request loadDiscusion(Request request) {
		return dao.loadDiscusion(request);
	}

}
